Proc Calc_LL_GEOREF 'Eingabe-Format:" 53 23' 32'' N 007 45' 52'' E"
Parameters LL$
Declare ALPHABET$,RECHTSG!,RECHTSM!,RECHTSS!,RECHTS!,RECHTSA%,RECHTSB%,RECHTS$
Declare HOCHG!,HOCHM!,HOCHS!,HOCH!,HOCHA%,HOCHB%,HOCH$,CALC1$,CALC2$
Declare Georef$,CALC1!,CALC2!,CALC3!,CALC4!,CALC1%,CALC2%,CALC3%,CALC4%,CALC3$,CALC4$
ALPHABET$="A;B;C;D;E;F;G;H;J;K;L;M;N;P;Q;R;S;T;U;V;W;X;Y;Z"
$O+
RECHTSG! = (@val(@mid$(LL$,17,3)) * 1)
RECHTSM! = (@val(@mid$(LL$,22,2)) / 60)  
RECHTSS! = (@val(@mid$(LL$,26,2)) / 3600)
RECHTS! = ((RECHTSG! + RECHTSM!) + RECHTSS!)
IF @equ$(@mid$(LL$,31,1),"E")
 RECHTS! = (180 + RECHTS!)
ELSE
 RECHTS! = (180 - RECHTS!)
ENDIF
RECHTSA% = (RECHTS! / 15) 
RECHTSB% = (RECHTS! - (RECHTSA%  * 15))
RECHTS$ = @substr$(ALPHABET$,(RECHTSA% + 1),";");@substr$(ALPHABET$,(RECHTSB% + 1),";")
HOCHG! = (@val(@mid$(LL$,2,2)) * 1)
HOCHM! = (@val(@mid$(LL$,6,2)) / 60)  
HOCHS! = (@val(@mid$(LL$,10,2)) / 3600)
HOCH! = ((HOCHG! + HOCHM!) + HOCHS!)
IF @equ$(@mid$(LL$,15,1),"N")
 HOCH! = (90 + HOCH!)
ELSE
 HOCH! = (90 - HOCH!)
ENDIF
HOCHA% = (HOCH! / 15) 
HOCHB% = (HOCH! - (HOCHA%  * 15))
HOCH$ = @substr$(ALPHABET$,(HOCHA% + 1),";");@substr$(ALPHABET$,(HOCHB% + 1),";")
Georef$ = " ";@left$(RECHTS$,1);@left$(HOCH$,1),@right$(RECHTS$,1);@right$(HOCH$,1)
CALC1! = (@val(@substr$(@Str$(RECHTS!),2,".")) / 1000000)
CALC1% = (CALC1! * 60)
CALC2! = (@val(@substr$(@Str$(HOCH!),2,".")) / 1000000)
CALC2% = (CALC2! * 60)
CALC3! = (((@val(@substr$(@Str$(RECHTS!),2,".")) / 1000000) * 60) - CALC1%)
CALC3% = ((CALC3! * 60) / 0.6)
CALC4! = (((@val(@substr$(@Str$(HOCH!),2,".")) / 1000000) * 60) - CALC2%)
CALC4% = ((CALC4! * 60) / 0.6)
CALC1$ = "00";@Str$(CALC1%)
CALC1$ = @RIGHT$(CALC1$,2)
CALC2$ = "00";@Str$(CALC2%)
CALC2$ = @RIGHT$(CALC2$,2)
CALC3$ = "00";@Str$(CALC3%)
CALC3$ = @RIGHT$(CALC3$,2)
CALC4$ = "00";@Str$(CALC4%)
CALC4$ = @RIGHT$(CALC4$,2)
$O-
Georef$ = Georef$,CALC1$;CALC3$,CALC2$;CALC4$
Return georef$
Endproc


Proc Calc_LL_UTMREF 'Eingabe-Format:" 53 23' 32'' N 007 45' 52'' E"
Parameters LL$
$O+
Declare UTMREF$,Deg2Rad!,F0!,A1!,B1!,K0!,N0!,E0!,N1!,N2!,N3!,E2!,Lat!,Long!
Declare K!,L!,SINK!,COSK!,TANK!,TANK2!,COSK2!,COSK3!,K3!,K4!,Merid%,J3!,J4!,J5!,J6!,M!
Declare Temp!,V!,R!,H2!,P!,L0!,P2!,P4!,North!,INorth$,East!,IEast$,J7!,J8!,J9!
Declare Eaststr$,NorthStr$,Letters$,Pos%,LatZone$,LongZone%,GR$,GR100km%,GR100km$,GRremainder$
Declare E100km$,N100km$,P%
  Deg2Rad!= (PI() / 180)
    'Daten fr WGS84############
    F0!=0.9996
    A1!=(6378137.0 * F0!)
    B1!=(6356752.3142 * F0!)
    K0!=0
    N0!=0
    E0!=500000
    '###########################

    N1!=((A1! - B1!) / (A1! + B1!))
    N2!=(N1! * N1!)
    N3!=(N2! * N1!)
    E2!=(((A1! * A1!) - (B1! * B1!)) / (A1! * A1!))
    Lat!=(1 * @abs(@val(@mid$(LL$,2,2))))
    Lat!=(Lat! + (@abs(@val(@mid$(LL$,6,2))) / 60))
    Lat!=(Lat! + (@abs(@val(@mid$(LL$,10,2))) / 3600))
    case @equ$(@mid$(LL$,15,1),"S"):Lat!=(Lat! * -1)
    Long!=(1 * @abs(@val(@mid$(LL$,17,3))))
    Long!=(Long! + (@abs(@val(@mid$(LL$,22,2))) / 60))
    Long!=(Long! + (@abs(@val(@mid$(LL$,26,2))) / 3600))
    case @equ$(@mid$(LL$,31,1),"W"):Long!=(Long! * -1)
    K!=(Lat! * Deg2Rad!)
    L!=(Long! * Deg2Rad!)
    SINK!=@sin(K!)
    COSK!=@cos(K!)
    TANK!=(SINK! / COSK!)
    TANK2!=(TANK! * TANK!)
    COSK2!=(COSK! * COSK!)
    COSK3!=(COSK2! * COSK!)
    K3!=(K! - K0!)
    K4!=(K! + K0!)
    Merid% = ((@Round(((Long! / 6) - 0.5),0) * 6) + 3)   
      if ((Lat! >= 72) & (Long! >= 0))
          if (Long! < 9)
           Merid% = 3
          elseif (Long! < 21)
           Merid%=15
          elseif (Long! < 33)
           Merid%=27
          elseif (Long! < 42)
           Merid%=39
          Endif
      elseif ((Lat! >= 56) & (Lat! < 64))
          if ((Long! >= 3) & (Long! < 12))
          Merid% = 9
          Endif
      Endif
        L0!=(Merid% * Deg2Rad!) 
      
    ' Arc of Meridian
    J3!=(K3! * ((1 + N1!) + (1.25 * (N2! + N3!))))
    J4!=((sin(K3!) * cos(K4!)) * (3 * ((N1! + N2!) + (0.875 * N3!))))
    J5!=((sin(2 * K3!) * cos(2 * K4!)) * (1.875 * (N2! + N3!)))
    J6!=((((sin(3 * K3!) * cos(3 * K4!)) * 35) / 24) * N3!)
    M!=(((((J3! - J4!) + J5!) - J6!)) * B1!)

    ' VRH2
    Temp!= (1 - ((E2! * SINK!) * SINK!))
    V!=(A1! / sqrt(Temp!))
    R!=((V! * (1 - E2!)) / Temp!)
    H2!=((V! / R!) - 1)
    P!=(L! - L0!)
    P2!=(P! * P!)
    P4!=(P2! * P2!)
    J3!=(M! + N0!)
    J4!=(((V! / 2) * SINK!) * COSK!)
    J5!=((((V! / 24) * SINK!) * COSK3!) * ((5 - TANK2!) + (9 * H2!)))
    J6!=(((((V! / 720) * SINK!) * COSK3!) * COSK2!) * ((61 - (58 * TANK2!)) + (TANK2! * TANK2!)))
    North!= (((J3! + (P2! * J4!)) + (P4! * J5!)) + ((P4! * P2!) * J6!))
    Case @equ$(@mid$(LL$,15,1),"S"):North!=(North! + 10000000) ' UTM S hemisphere
    J7!=(V! * COSK!)
    J8!=(((V! / 6) * COSK3!) * ((V! / R!) - TANK2!))
    J9!=(((V! / 120) * COSK3!) * COSK2!)
    J9!=(J9!* (((((5 - (18 * TANK2!)) + (TANK2! * TANK2!)) + (14 * H2!)) - ((58 * TANK2!) * H2!))))
    East!=(((E0! + (P! * J7!)) + ((P2! * P!) * J8!)) + ((P4! * P!) * J9!))
    IEast$=@substr$(@str$(@abs(round(East!,0))),1,".")
    INorth$=@substr$(@str$(@abs(round(North!,0))),1,".")
    '## Ab hier Umwandlung von UTM in UTMREF
    EastStr$=IEast$
    NorthStr$=INorth$
    EastStr$ = "0000000";EastStr$
    EastStr$ = @Right$(EastStr$,7)
    NorthStr$ = "0000000";NorthStr$
    NorthStr$ = @Right$(NorthStr$,7)
    GR100km$=@mid$(EastStr$,2,1);@mid$(NorthStr$,2,1)
    GR100km%=@val(gr100km$)
    GRremainder$=@mid$(EastStr$,3,5),@mid$(NorthStr$,3,5)
    LongZone%=(((Merid% - 3) / 6) + 31)
    ifnot @equ(@mod(LongZone%,1),0)
      UTMREF$="Kein Mittelmeridian"
    else
       if (East! < 100000)
        UTMREF$="Auerhalb vom UTMREF-Bereich"
       elseif (Lat! < -80)
        UTMREF$="Auerhalb vom UTMREF-Bereich"
       elseif (East! > 899999)
        UTMREF$="Auerhalb vom UTMREF-Bereich"
       elseif (Lat! >= 84)
        UTMREF$="Auerhalb vom UTMREF-Bereich"
       else
        Letters$="ABCDEFGHJKLMNPQRSTUVWXYZ"
        Pos%=((round(((Lat! / 8) - 0.5),0) + 10) + 2)
        LatZone$=@mid$(Letters$,(Pos% + 1),1) 
        Case @equ$(LatZone$,"Y"):LatZone$="X"
        Pos%=round(((abs(North!) / 100000) - 0.5),0)
        WHILENOT @lt(Pos%,20)
        POS% = (POS% - 20)
        ENDWHILE
        if @equ(@mod(LongZone%,2),0)
          POS% = (POS% + 5)
          Case @gt(POS%,19):POS% = (POS% - 20)
        endif
        
        N100km$=@mid$(Letters$,(POS% + 1),1) 


        Pos%=((GR100km% / 10) - 1)
        P%=LongZone%
        WHILENOT @lt(P%,4)
        P% = (P% - 3)
        ENDWHILE
        Pos%=(Pos% + ((P% - 1)* 8))
        E100km$=@mid$(Letters$,(POS% + 1),1)
        Utmref$=" ";@str$(Longzone%);LatZone$,E100km$;N100km$,GRremainder$
        Endif
      Endif
Return utmref$
$O-
Endproc

Proc Calc_LL_UTM 'Eingabe-Format:" 53 23' 32'' N 007 45' 52'' E"
Parameters LL$
$O+
Declare UTM$,Deg2Rad!,F0!,A1!,B1!,K0!,N0!,E0!,N1!,N2!,N3!,E2!,Lat!,Long!
Declare K!,L!,SINK!,COSK!,TANK!,TANK2!,COSK2!,COSK3!,K3!,K4!,Merid%,J3!,J4!,J5!,J6!,M!
Declare Temp!,V!,R!,H2!,P!,L0!,P2!,P4!,North!,INorth$,East!,IEast$,J7!,J8!,J9!
Declare LatZone$,LongZone%
  Deg2Rad!= (PI() / 180)
    'Daten fr WGS84############
    F0!=0.9996
    A1!=(6378137.0 * F0!)
    B1!=(6356752.3142 * F0!)
    K0!=0
    N0!=0
    E0!=500000
    '###########################

    N1!=((A1! - B1!) / (A1! + B1!))
    N2!=(N1! * N1!)
    N3!=(N2! * N1!)
    E2!=(((A1! * A1!) - (B1! * B1!)) / (A1! * A1!))
    Lat!=(1 * @abs(@val(@mid$(LL$,2,2))))
    Lat!=(Lat! + (@abs(@val(@mid$(LL$,6,2))) / 60))
    Lat!=(Lat! + (@abs(@val(@mid$(LL$,10,2))) / 3600))
    case @equ$(@mid$(LL$,15,1),"S"):Lat!=(Lat! * -1)
    Long!=(1 * @abs(@val(@mid$(LL$,17,3))))
    Long!=(Long! + (@abs(@val(@mid$(LL$,22,2))) / 60))
    Long!=(Long! + (@abs(@val(@mid$(LL$,26,2))) / 3600))
    case @equ$(@mid$(LL$,31,1),"W"):Long!=(Long! * -1)
    K!=(Lat! * Deg2Rad!)
    L!=(Long! * Deg2Rad!)
    SINK!=@sin(K!)
    COSK!=@cos(K!)
    TANK!=(SINK! / COSK!)
    TANK2!=(TANK! * TANK!)
    COSK2!=(COSK! * COSK!)
    COSK3!=(COSK2! * COSK!)
    K3!=(K! - K0!)
    K4!=(K! + K0!)
    Merid% = ((@Round(((Long! / 6) - 0.5),0) * 6) + 3)  
      if ((Lat! >= 72) & (Long! >= 0))
          if (Long! < 9)
           Merid% = 3
          elseif (Long! < 21)
           Merid%=15
          elseif (Long! < 33)
           Merid%=27
          elseif (Long! < 42)
           Merid%=39
          Endif
      elseif ((Lat! >= 56) & (Lat! < 64))
          if ((Long! >= 3) & (Long! < 12))
          Merid% = 9
          Endif
      Endif
        L0!=(Merid% * Deg2Rad!) 
      
    ' Arc of Meridian
    J3!=(K3! * ((1 + N1!) + (1.25 * (N2! + N3!))))
    J4!=((sin(K3!) * cos(K4!)) * (3 * ((N1! + N2!) + (0.875 * N3!))))
    J5!=((sin(2 * K3!) * cos(2 * K4!)) * (1.875 * (N2! + N3!)))
    J6!=((((sin(3 * K3!) * cos(3 * K4!)) * 35) / 24) * N3!)
    M!=(((((J3! - J4!) + J5!) - J6!)) * B1!)

    ' VRH2
    Temp!= (1 - ((E2! * SINK!) * SINK!))
    V!=(A1! / sqrt(Temp!))
    R!=((V! * (1 - E2!)) / Temp!)
    H2!=((V! / R!) - 1)
    P!=(L! - L0!)
    P2!=(P! * P!)
    P4!=(P2! * P2!)
    J3!=(M! + N0!)
    J4!=(((V! / 2) * SINK!) * COSK!)
    J5!=((((V! / 24) * SINK!) * COSK3!) * ((5 - TANK2!) + (9 * H2!)))
    J6!=(((((V! / 720) * SINK!) * COSK3!) * COSK2!) * ((61 - (58 * TANK2!)) + (TANK2! * TANK2!)))
    North!= (((J3! + (P2! * J4!)) + (P4! * J5!)) + ((P4! * P2!) * J6!))
    Case @equ$(@mid$(LL$,15,1),"S"):North!=(North! + 10000000) ' UTM S hemisphere
    J7!=(V! * COSK!)
    J8!=(((V! / 6) * COSK3!) * ((V! / R!) - TANK2!))
    J9!=(((V! / 120) * COSK3!) * COSK2!)
    J9!=(J9!* (((((5 - (18 * TANK2!)) + (TANK2! * TANK2!)) + (14 * H2!)) - ((58 * TANK2!) * H2!))))
    East!=(((E0! + (P! * J7!)) + ((P2! * P!) * J8!)) + ((P4! * P!) * J9!))
    IEast$=@substr$(@str$(@abs(round(East!,0))),1,".")
    INorth$=@substr$(@str$(@abs(round(North!,0))),1,".")
    LongZone%=(((Merid% - 3) / 6) + 31)
    Utm$=" ";@str$(LongZone%),@mid$(LL$,15,1),IEast$,INorth$
Return utm$
$O-
Endproc

